/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2008 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * File Name: fckplugin.js
 * 	Plugin to insert "debug" in the editor.
 *
 * File Authors:
 *  Akira Taniguchi (akira@behappy.2-d.jp)
 */

if ( FCKBrowserInfo.IsIE )
{

	// Fix IE IMG

	FCKEditingArea.prototype.ToolbarSpace_OnMouseLeave = function()
	{
		if ( ! FCK.EditingArea.IE_Range ) return ;

		FCK.IsSelectionChangeLocked = true ;

		FCK.EditingArea.IE_Range.select() ;
		FCK.EditingArea.IE_Range = null ;

		FCK.IsSelectionChangeLocked = false ;
	}


	FCKEditingArea.prototype.ToolbarSpace_OnMouseEnter = function()
	{
		if ( FCK.EditorDocument.selection.type != 'Control' ) return ;

		var oRange = FCK.EditorDocument.selection.createRange() ;
		if ( oRange.length != 1 ) return ;
		if ( oRange.item( 0 ).tagName != 'IMG' ) return ;

		FCK.IsSelectionChangeLocked = true ;

		var scroll = FCK.EditorDocument.body.scrollTop ;
		FCK.EditingArea.IE_Range = oRange ;
		FCK.EditorDocument.selection.empty() ;
		FCK.EditorDocument.body.scrollTop = scroll ;

		FCK.IsSelectionChangeLocked = false ;
	}


	FCK.OnAfterSetHTML = function()
	{
		FCK.EditingArea.IE_Range = null ;
		var eToolbarSpace = document.getElementById( 'xToolbarSpace' ) ;
		FCKTools.AddEventListener( eToolbarSpace, 'mouseenter', FCK.EditingArea.ToolbarSpace_OnMouseEnter ) ;
		FCKTools.AddEventListener( eToolbarSpace, 'mouseleave', FCK.EditingArea.ToolbarSpace_OnMouseLeave ) ;

		FCKDocumentProcessor.Process( FCK.EditorDocument ) ;
		FCKUndo.SaveUndoStep() ;

		FCK.Events.FireEvent( 'OnSelectionChange' ) ;
		FCK.Events.FireEvent( 'OnAfterSetHTML' ) ;
	}


	function FCKToolbarButtonUI_OnClick( ev, button )
	{
		if ( button.OnClick && button.State != FCK_TRISTATE_DISABLED )
		{
			FCK.EditingArea.ToolbarSpace_OnMouseLeave() ;
			button.OnClick( button ) ;
		}
	}
}
